//
// ECE264 PA 4
// Yung-Hsiang Lu, ECE Purdue University
// Spring 2009
//
#include "rectwin.h"
#include "rectlist.h"
#include <stdlib.h>
#include <iostream>
using namespace std;
static const QColor backgroundColor = Qt::white;
// use saturated colors to provide better contrast
static const QColor availColor[] =
  {
    Qt::red,
    Qt::green,
    Qt::blue,
    Qt::cyan,
    Qt::magenta,
    Qt::yellow,
    Qt::gray,
    Qt::darkRed,
    Qt::darkGreen,
    Qt::darkBlue,
    Qt::darkCyan,
    Qt::darkMagenta,
    Qt::darkYellow,
    Qt::darkGray
  };
static const int numColor = sizeof(availColor) / sizeof(QColor);
static const int initWidth = 800;
static const int initHeight = 800;

RectWin::RectWin(int argc, char * argv[], RectList * rects, 
		 QWidget *parent): QWidget(parent)
{
  setMinimumSize(initWidth, initHeight);
  rw_list = rects;
  update();
}

void RectWin::paintEvent(QPaintEvent *event)
{
  int rww = width(); 
  int rwh = height();
  // draw background
  QPainter painter(this);
  painter.setBrush(backgroundColor);
  painter.drawRect(0, 0, rww, rwh);
  double xScale = 1.0 * rww / (rw_list -> rl_maxX);
  double yScale = 1.0 * rwh / (rw_list -> rl_maxY);
  double xyScale = xScale; // choose the smaller one
  if (xScale > yScale) { xyScale = yScale; }
  /*
  cout << "maxX " << rw_list -> rl_maxX
       << " maxY " << rw_list -> rl_maxY
       << " xyScale " << xScale << endl;
  */
  QList<Rectangle>::iterator iter = rw_list -> rl_list.begin();
  int colorCounter = 0;
  painter.setPen(Qt::black);
  painter.setOpacity(0.5);
  while (iter != rw_list -> rl_list.end())
    {
      QColor clr = availColor[colorCounter % numColor];
      colorCounter ++;
      // cout << clr.name().toAscii().data() << endl;
      int xCoor = (int) (xyScale * (*iter).r_rect.x());
      int yCoor = (int) (xyScale * (*iter).r_rect.y());
      int rectWidth = (int) (xyScale * (*iter).r_rect.width());
      int rectHeight = (int) (xyScale * (*iter).r_rect.height());
      /*
      cout << "Rectangle id = " << (*iter).r_id
	   << " " << xCoor 
	   << " " << yCoor
	   << " " << rectWidth
	   << " " << rectHeight << endl;
      */
      if ((*iter).r_rotate == true)
	{
	  painter.fillRect(xCoor, yCoor, rectHeight, rectWidth,
			   QBrush(clr));
	  painter.drawRect(xCoor, yCoor, rectHeight, rectWidth);
	}
      else
	{
	  painter.fillRect(xCoor, yCoor, rectWidth, rectHeight, 
			   QBrush(clr));
	  painter.drawRect(xCoor, yCoor, rectWidth, rectHeight);
	}
      iter ++;
    }
}
